﻿package supermotion3d
{
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;

	public class Camera3D
	{
		//カメラ上向き三次元ベクトル
		private var _up:Vector3D = new Vector3D(0, 1, 0);
		//カメラ注視点三次元ベクトル
		private var _lookAt:Vector3D = new Vector3D();
		//カメラ位置三次元ベクトル
		private var _position:Vector3D = new Vector3D();
		//カメラ向き三次元ベクトル
		private var _direction:Vector3D = new Vector3D();

		public function Camera3D():void
		{
		}

		public function get x():Number
		{
			return _position.x;
		}

		public function set x(value:Number):void
		{
			_position.x = value;
		}

		public function get y():Number
		{
			return _position.y;
		}

		public function set y(value:Number):void
		{
			_position.y = value;
		}

		public function get z():Number
		{
			return _position.z;
		}

		public function set z(value:Number):void
		{
			_position.z = value;
		}

		public function get position():Vector3D
		{
			return _position;
		}

		public function set position(value:Vector3D):void
		{
			_position = value;
		}

		//カメラの向き「注視点－位置」を正規化(長さ1にする計算)
		public function get direction():Vector3D
		{
			_direction.x = _lookAt.x - _position.x;
			_direction.y = _lookAt.y - _position.y;
			_direction.z = _lookAt.z - _position.z;
			
			_direction.normalize();
			
			return _direction;
		}

		public function get lookAt():Vector3D
		{
			return _lookAt;
		}
		
		public function set lookAt(value:Vector3D):void
		{
			_lookAt = value;
		}

		//ビュー行列を計算し、行列値を返す
		public function viewMatrix():Matrix3D
		{
			var zAxis:Vector3D = direction;

			var xAxis:Vector3D = _up.crossProduct(zAxis);
			xAxis.normalize();

			var yAxis:Vector3D = zAxis.crossProduct(xAxis);

			var m:Matrix3D = new Matrix3D();

			m.rawData = Vector.<Number>([
				xAxis.x,yAxis.x,zAxis.x,0,
				xAxis.y,yAxis.y,zAxis.y,0,
				xAxis.z,yAxis.z,zAxis.z,0,
				-position.dotProduct(xAxis),
				-position.dotProduct(yAxis),
				-position.dotProduct(zAxis),
				1]);

			return m;
		}
	}
}
