﻿package supermotion3d
{
	import flash.display.Sprite;
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;
	import flash.geom.PerspectiveProjection;
	import flash.geom.Point;

	public class Scene3D
	{
		public var _container:Sprite;
		public var _objects :Array = new Array();
		//プロジェクション
		public var _projection:PerspectiveProjection = new PerspectiveProjection();

		public function Scene3D(container:Sprite,fov:Number=45):void
		{
			_container = container;

			_projection.projectionCenter = new Point(0, 0);
			_projection.fieldOfView = fov;
		}

		public function addChild(child:Model3D):Model3D
		{
			_container.addChild(child);
			_objects.push(child);
			return child;
		}

		public function removeChild(child:Model3D):Model3D
		{
			_container.removeChild(child);
	
			for (var i:int = 0; i < _objects.length; i++ )
			{
				if (_objects[i] === child )
				{
					_objects.splice(i, 1);
					return child;
				}
			}
			return null;
		}

		public function render(camera:Camera3D):void
		{
			var obj:Model3D;
			var index:Array = new Array();
			//ビュー行列
			var view:Matrix3D = camera.viewMatrix().clone();
			//パーツごとのZ位置を計算
			for each ( obj in _objects )
			{
				var center:Vector3D = view.transformVector(obj.position);
			    index.push(center.z);
			}
			//パーツごとのZソート(奥のものから順番に並べる)
			index = index.sort(Array.RETURNINDEXEDARRAY | Array.NUMERIC);
			//奥のパーツから順に描画
			for each( var idx:int in index )
			{
				obj = _objects[idx];
				//動きセット
				obj.updateMatrix();
				//レンダリング
				obj.draw(view,_projection.toMatrix3D());
				//手前に持ってくる
				_container.setChildIndex(obj,0);
				//アニメーション再生
				obj.playAnimation();
			}
		}
	}
}